///////////////////////////////////////////////////////////
// DIAGMENU.CPP
///////////////////////////////////////////////////////////

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\button.h>
#pragma hdrstop
#include "diagmenu.rh"

//////////////////////////////////
// The dialog class.
//////////////////////////////////
class TDlg : public TDialog
{
public:
	TDlg(TWindow *parent, TResId resId);
protected:
	BOOL PreProcessMsg(MSG& msg) {
		if (Parent->PreProcessMsg(msg))
			return TRUE;
		return TDialog::PreProcessMsg(msg);
//		return (Parent&&Parent->PreProcessMsg(msg))
//			? TRUE : TDialog::PreProcessMsg(msg);
	}
	void EvSysCommand(uint cmdType, TPoint& p);
	void CmCancel();
	BOOL CanClose();
	void CmPushButton1();
	void CmPushButton2();
private:
	TButton *button1;
	TButton *button2;
DECLARE_RESPONSE_TABLE(TDlg);
};

DEFINE_RESPONSE_TABLE1(TDlg, TDialog)
	EV_WM_SYSCOMMAND,
	EV_COMMAND(IDC_PUSHBUTTON1, CmPushButton1),
	EV_COMMAND(IDC_PUSHBUTTON2, CmPushButton2),
	EV_COMMAND(IDCANCEL, CmCancel),
END_RESPONSE_TABLE;

TDlg::TDlg(TWindow *parent, TResId resId)
	: TDialog(parent, resId)
{
	button1 = new TButton(this, IDC_PUSHBUTTON1);
	button2 = new TButton(this, IDC_PUSHBUTTON2);
}


void TDlg::CmPushButton1()
{
	MessageBox("Got IDC_PUSHBUTTON1!", "Message");
}


void TDlg::CmPushButton2()
{
	MessageBox("Got IDC_PUSHBUTTON2!", "Message");
}


void TDlg::EvSysCommand(uint cmdType, TPoint& /*p*/)
{
	if ((cmdType & 0xFFF0) == SC_CLOSE) {
		if (!CanClose())
			return;
	}
	DefaultProcessing();
}


void TDlg::CmCancel()
{
	if (CanClose())
		TDialog::CmCancel();
}


BOOL TDlg::CanClose()
{
	int choice = MessageBox("Would like to exit?", "Exit",
		MB_ICONQUESTION | MB_OKCANCEL);
	if (choice == IDOK)
		return TRUE;
	return FALSE;
}

//////////////////////////////////
// The application class.
//////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};

///////////////////////////////////////////////////////////
// TApp::InitMainWindow()
///////////////////////////////////////////////////////////
void TApp::InitMainWindow()
{
	// Construct the dialog box.
	TDialog *dialog = new TDlg(0, TESTDLG);

	// Construct the main window with the
	// dialog box as the client window.
	TFrameWindow *wndw =
		new TFrameWindow(0, "Main Dialog with Menu",
		dialog, TRUE);

	// Assign a menu to the main window.
	wndw->AssignMenu(MENU_1);
	wndw->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
	wndw->Attr.AccelTable = MENU_1;

	SetMainWindow(wndw);
	EnableCtl3d();
}

///////////////////////////////////////////////////////////
// OwlMain()
///////////////////////////////////////////////////////////
int OwlMain(int, char*[])
{
   return TApp().Run();
}


